function [bhat,residuos,sigma2,vcov,estadt,pvalort,R2]=mco(y,xx);

%  Estimacion por MCO de un modelo lineal
%  y: vector Tx1. Variable a explicar
%  x: matriz Txk. Variables explicativas
%  bhat: coeficientes estimados
%  residuos: residuos
%  sigma2: varianza residual
%  vcov: matriz de covarianzas de coeficientes estimados
%  estadt: estadistico t para el contraste individual
%  pvalort: p-valor del contraste individual
%  R2: Coeficiente de determinacion
%  adaptado de G.M.D. 2000


n = size(y,1);
k = size(xx,2);
xinv = inv(xx'*xx);
display('coeficientes estimados')
bhat = xinv*(xx'*y)
residuos = y-xx*bhat;
sigma2 = (residuos'*residuos)/(n-k);
R2 = 1.0-(residuos'*residuos)/((y-mean(y))'*(y-mean(y)));
vcov = sigma2.*xinv;
estadt = bhat./sqrt(diag(vcov));
pvalort = 1.0-tcdf(abs(estadt),n-k);
std = diag(vcov);

