
%    This program estimates the discretized version of a diffusion by Maximum Likelihood
%    The discrete version is not the exact one.
%    It computes initial estimates for the (inexact) discretized diffusion
%    r(t)-r(t-1) = a+br(t-1)+u(t)  with u(t) a zero mean process with conditional variance,
%    (sigma^2)[r(t-1)^2c]

clear
load tipos.prn -ascii;
T = size(tipos,1);
r = tipos(2:T,1);
lagr = tipos(1:T-1,1);

dr = tipos(2:T,1)-tipos(1:T-1,1);
display('r   dr  lagr');
[r(1:5,1) dr(1:5,1) lagr(1:5,1)]
[r(T-5:T-1,1) dr(T-5:T-1,1) lagr(T-5:T-1,1)]
% plot(dr);
% pause
% plot(lagr);
% pause

y = dr;
xx = [ones(T-1,1) lagr];

[bhat1,residuos,sigma2,vcov,estadt,pvalort,R2] = mco_breve(y,xx);
p = [bhat1(1) bhat1(2) sigma2 .0]'

%  Calculo de pre-estimaciones de parametros en ecuacion de varianza
  res2 = residuos.^2;
  [bhat2,ehat2,sigma2,sigbhat,estadt,pvalor,R2] = mco_breve(res2,[ones(T-1,1) log(lagr)]);
  p = [bhat1(1) bhat1(2) exp(bhat2(1)) .5*bhat2(2)]'

[pcnew,iter,fnew,gnew,hessian] = eemin5('ver_general',p,'',dr,lagr)
vart2 = pcnew(3,1)*(lagr.^(2*pcnew(4,1)));
plot(vart2);
pause

dt = diag(inv(hessian))./T
% dt = diag(inv(gnew*gnew'))./T;
display('estimates   std   t-ratios')
[pcnew dt pcnew./dt]
display('minimized objective function')
fnew



