
%    This program estimates the discretized version of a diffusion by Maximum Likelihood
%    The discrete version is not the exact one.
%    It computes initial estimates for the (inexact) discretized diffusion
%    r(t)-r(t-1) = a+br(t-1)+u(t)  with u(t) a zero mean process with conditional variance,
%    (sigma^2)[r(t-1)^2c]


load tipos.prn;
T = size(tipos,1);
lr = tipos(1:T-1,1);

dr = tipos(2:T,1)-tipos(1:T-1,1);

y = dr;
xx = [ones(T-1,1) lr];

[bhat,residuos,sigma2,vcov,estadt,pvalort,R2] = mco(y,xx);

p = [bhat(1) bhat(2) sigma2]';

[pcnew,iter,fnew,gnew,hessian] = eemin5('verosimilitud',p,'',dr,lr)

dt = diag(inv(hessian))./T;
% dt = diag(inv(gnew*gnew'))./T;
display('estimates   std   t-ratios')
[pcnew dt pcnew./dt]
display('minimized objective function')
fnew



