%  This function evaluates the quadratic form for estimation by 
%  General method of Momentos of a diffusion
%  The discretized diffusion is,
%  r(t)-r(t-1) = a + b*r(t-1) + u(t)  with u(t) a zero mean process with conditional variance,
%  (sigma^2)[r(t-1)^2c]
%
%  Moment conditions are,  E[u(t)]=0, E[u(t)r(t-1)]=0
%  E{u(t)^2-(sigma^2)[r(t-1)^2c]}=E(X(t)]=0, E[X(t)r(t-1)]=0  


function [qform,A,mh] = forqua(parm,dr,lagr);

T = size(dr,1);
et = dr-parm(1,1)-parm(2,1)*lagr;
h11 = et;
h12 = h11.^2-(parm(3,1)^2).*(lagr.^(2*parm(4,1)));
h21 = h11.*lagr;
h22 = h12.*lagr;
%h21 = h11.*lag2r;
%h22 = h12.*lag2r;

h = [h11 h12 h21 h22];
A = inv(h'*h./T);
mh = mean(h);

qform = mh*A*mh';
