%  This function computes initial estimates for GMM estimation
%  of approximate diffusion processes for interest rates


function [formquad] = initial(parm,dr,lr);

et = dr-parm(1,1)-parm(2,1)*lr;
h11 = et;
h12 = h11.^2-(parm(3,1)^2).*(lr.^(2*parm(4,1)));
h21 = h11.*lr;
h22 = h12.*lr;

h = [h11 h12 h21 h22];
mh = mean(h);

formquad = mh*mh';